/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of EV.xs. Do not edit this file, edit EV.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "EV.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "wslay/wslay.h"
#include "wslay_net.c"
#include "wslay_frame.c"
#include "wslay_queue.c"
#include "wslay_event.c"

#include "EVAPI.h"

//windows
#ifdef WIN32
	#ifndef EWOULDBLOCK
		#define EWOULDBLOCK     WSAEWOULDBLOCK
	#endif
#else
	#ifndef EWOULDBLOCK
		#define EWOULDBLOCK     EAGAIN
	#endif
#endif

#define FRAGMENTED_EOF 0
#define FRAGMENTED_ERROR -1
#define FRAGMENTED_DATA 1




typedef struct {
	wslay_event_context_ptr ctx;
	
	HV* perl_callbacks;
	
	ev_io io;
	
	SV* queue_wait_cb;
	
	struct wslay_event_callbacks callbacks;
	
	char read_stopped;
	char write_stopped;
	
} websocket_object;

static void wait_io_event(websocket_object* websock_object);

static ssize_t recv_callback(wslay_event_context_ptr ctx, uint8_t *buf, size_t len, int flags, void *data){
	websocket_object* websock_object = (struct websocket_object*) data;
	
	ssize_t r;
	while((r = recv(websock_object->io.fd, buf, len, 0)) == -1 && errno == EINTR);
	if(r == -1) {
		if(errno == EAGAIN || errno == EWOULDBLOCK) {
			wslay_event_set_error(ctx, WSLAY_ERR_WOULDBLOCK);
		} else {
			wslay_event_set_error(ctx, WSLAY_ERR_CALLBACK_FAILURE);
		}
	} else if(r == 0) {
	/* Unexpected EOF is also treated as an error */
		wslay_event_set_error(ctx, WSLAY_ERR_CALLBACK_FAILURE);
		r = -1;
	}
	
	return r;
}

static ssize_t send_callback(wslay_event_context_ptr ctx, const uint8_t *buf, size_t len, int flags, void *data){
	websocket_object* websock_object = (struct websocket_object*) data;
	
	ssize_t r;
	
	int sflags = 0;
	#ifdef MSG_MORE
		if(flags & WSLAY_MSG_MORE) {
			sflags |= MSG_MORE;
		}
	#endif // MSG_MORE
	
	while((r = send(websock_object->io.fd, buf, len, sflags)) == -1 && errno == EINTR);
	if(r == -1) {
		if(errno == EAGAIN || errno == EWOULDBLOCK) {
			wslay_event_set_error(ctx, WSLAY_ERR_WOULDBLOCK);
		} else {
			wslay_event_set_error(ctx, WSLAY_ERR_CALLBACK_FAILURE);
		}
	}
	return r;
}

static websocket_object* get_wslay_context(SV* sv){
	MAGIC* mg ;
	for (mg = SvMAGIC ( sv ); mg; mg = mg->mg_moremagic) {
		if (mg->mg_type == PERL_MAGIC_ext && mg->mg_virtual == NULL){
			return (websocket_object*) mg->mg_ptr;
		}	
	}
	croak("Can't get ptr from object hash!\n");
}


/// wslay cb's

int genmask_callback(wslay_event_context_ptr ctx, uint8_t *buf, size_t len, void *data){
	websocket_object* websock_object = (struct websocket_object*) data; 
	
	SV** cb;
	if( cb = hv_fetch( websock_object->perl_callbacks , "genmask", 7, 0) ) {
		dSP;
		ENTER;
		SAVETMPS;

		PUSHMARK(SP);
		XPUSHs(sv_2mortal(newSViv(len)));
		PUTBACK;

			int count = call_sv( *cb , G_SCALAR);

		SPAGAIN;

		
		int status;
		
		if(count != 1){
			croak("Wslay - genmask callback returned bad value!\n");
		}
		SV* data = POPs;
		
		STRLEN souce_len;
		char *source_buf = SvPV(data, souce_len);
		if(souce_len){
			memcpy ( buf, source_buf, ( souce_len < len ? souce_len : len ) );
		}
		
		PUTBACK;
		FREETMPS;
		LEAVE; 
		
		return 0;
	};
	
	int i = 0;
	for(; i < len; i++){
		buf[i] = (char) rand();
	}
	return 0;
}

static void on_frame_recv_start_callback (wslay_event_context_ptr ctx, const struct wslay_event_on_frame_recv_start_arg *frame, void *data){

	SV** cb;
	if(!( cb = hv_fetch( ((websocket_object*) data)->perl_callbacks , "on_frame_recv_start", 19, 0) ) ){
		warn("Wslay - cant find on_frame_recv_start callback!\n");
		return;
	}


	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK(SP);
	EXTEND(SP, 4);
	PUSHs(sv_2mortal(newSViv(frame->fin)));
	PUSHs(sv_2mortal(newSViv(frame->rsv)));
	PUSHs(sv_2mortal(newSViv(frame->opcode)));
	PUSHs(sv_2mortal(newSViv(frame->payload_length)));
	PUTBACK;
	
	call_sv(*cb, G_VOID);
	
	FREETMPS;
	LEAVE;
}

static void on_frame_recv_chunk_callback (wslay_event_context_ptr ctx, const struct wslay_event_on_frame_recv_chunk_arg *chunk, void *data){

	SV** cb;
	if(!( cb = hv_fetch( ((websocket_object*) data)->perl_callbacks , "on_frame_recv_chunk", 19, 0) ) ){
		warn("Wslay - cant find on_frame_recv_chunk callback!\n");
		return;
	}

	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK(SP);
	EXTEND(SP, 1);
	PUSHs(sv_2mortal(newSVpvn(chunk->data, chunk->data_length)));
	PUTBACK;
	
	call_sv(*cb, G_VOID);
	
	FREETMPS;
	LEAVE;
}

static void on_frame_recv_end_callback(wslay_event_context_ptr ctx, void *data){
	
		SV** cb;
		if(!( cb = hv_fetch( ((websocket_object*) data)->perl_callbacks , "on_frame_recv_end", 17, 0) ) ){
			warn("Wslay - cant find on_frame_recv_end callback!\n");
			return;
		}
		
		dSP;
        PUSHMARK(SP);
		
        call_sv(*cb, G_DISCARD|G_NOARGS);
}

static void on_msg_recv_callback (wslay_event_context_ptr ctx, const struct wslay_event_on_msg_recv_arg *msg,  void *data){

	if(msg->opcode == 0x08){
		return; // on_close calback is for close messages
	}

	SV** cb;
	if(!( cb = hv_fetch( ((websocket_object*) data)->perl_callbacks , "on_msg_recv", 11, 0) ) ){
		warn("Wslay - cant find on_msg_recv callback!\n");
		return;
	}

	SV* msg_data = newSVpvn(msg->msg, msg->msg_length);
	if(msg->opcode == 1){
		SvUTF8_on(msg_data);
	}

	dSP;
	ENTER;
	SAVETMPS;
	PUSHMARK(SP);
	EXTEND(SP, 4);
	PUSHs(sv_2mortal(newSViv(msg->rsv)));
	PUSHs(sv_2mortal(newSViv(msg->opcode)));
	PUSHs(sv_2mortal(msg_data));
	PUSHs(sv_2mortal(newSViv(msg->status_code)));
	PUTBACK;
	
	call_sv(*cb, G_VOID);
	
	FREETMPS;
	LEAVE;
}

ssize_t fragmented_msg_callback(wslay_event_context_ptr ctx, uint8_t *buf, size_t len, const union wslay_event_msg_source *source, int *eof, void *userdata){
	
	websocket_object* websock_object = (struct websocket_object*) userdata;
	ssize_t bytes_written = 0;
	
	dSP;
	ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(len)));
    PUTBACK;

		int count = call_sv( (SV*) source->data , G_ARRAY);

	SPAGAIN;

	SV* data;
	int status;
	
	if(count == 1){
		status = FRAGMENTED_DATA;
		data = POPs;
	}else
	if(count == 2){
		status = POPi;
		data = POPs;
	}else{
		croak("Wslay - fragmented msg cb MUST return one or two elements! \n");
	}
	
	STRLEN souce_len;
	char *source_buf = SvPV(data, souce_len);
	if(souce_len){
		bytes_written = (souce_len < len ? souce_len : len );
		memcpy ( buf, source_buf, bytes_written );
	}
	
	PUTBACK;
	FREETMPS;
	LEAVE; 
	
	if(status == FRAGMENTED_EOF){
		*eof = 1;
		SvREFCNT_dec((SV*) source->data);
	}else
	if(status == FRAGMENTED_ERROR){
		bytes_written = -1;
		wslay_event_set_error(websock_object->ctx, WSLAY_ERR_CALLBACK_FAILURE);
		SvREFCNT_dec((SV*) source->data);
	}
	// else - FRAGMENTED_DATA
	
	return bytes_written;
}


//////////////////////


static void close_connection(websocket_object* websock_object) {
	
	int status = wslay_event_get_status_code_received(websock_object->ctx);
	
	wslay_event_context_free(websock_object->ctx);
	websock_object->ctx = NULL;
	
	close(websock_object->io.fd);
	ev_io_stop(EV_DEFAULT, &(websock_object->io));
	
	
	SV** cb;
	if( cb = hv_fetch( websock_object->perl_callbacks , "on_close", 8, 0) ) {
		dSP;
		ENTER;
		SAVETMPS;
		PUSHMARK(SP);
		EXTEND(SP, 1);
		PUSHs(sv_2mortal(newSViv( status )));
		PUTBACK;
		
		call_sv(*cb, G_VOID);
		
		FREETMPS;
		LEAVE;
	};
}


static void wslay_io_event (struct ev_loop *loop, struct ev_io *w, int revents){
	websocket_object* websock_object = (websocket_object*) w->data;
	if (revents & EV_READ){
		if( wslay_event_recv(websock_object->ctx) ){
			close_connection(websock_object);
			return;
		}
	}
	if (revents & EV_WRITE){
		if( wslay_event_send(websock_object->ctx) ){
			close_connection(websock_object);
			return;
		}
	}
	
	wait_io_event(websock_object);
};

static void wait_io_event(websocket_object* websock_object) {
	ev_io_stop(EV_DEFAULT, &(websock_object->io)); 
	
	if(websock_object->read_stopped && websock_object->write_stopped){
		return;
	}
	
	int events = NULL;
	char wanted_io = 0;
	
	if( wslay_event_want_read(websock_object->ctx)){
		if(!websock_object->read_stopped){
			events |= EV_READ; 
		}
		
		wanted_io = 1;
	}
	if(wslay_event_want_write(websock_object->ctx)){
		if(!websock_object->write_stopped){
			events |= EV_WRITE;
		}
		wanted_io = 1;
	}else if( 
		websock_object->queue_wait_cb &&
		!wslay_event_get_queued_msg_count(websock_object->ctx)
	) {
		dSP;
		PUSHMARK(SP);
	
		call_sv(websock_object->queue_wait_cb, G_DISCARD|G_NOARGS);
		
		SvREFCNT_dec(websock_object->queue_wait_cb);
		websock_object->queue_wait_cb = NULL;
		
		//recheck want write, because user might queue messages in perl callback
		if(wslay_event_want_write(websock_object->ctx)){
			if(!websock_object->write_stopped){
				events |= EV_WRITE;
			}
			wanted_io = 1;
		}
	}
	
	if(events){
		ev_io_set (&(websock_object->io), websock_object->io.fd , events);
		
		ev_io_start(EV_DEFAULT, &(websock_object->io));
	} else 
	if(!wanted_io){
		close_connection(websock_object);
	}
	
};


#line 417 "EV.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 561 "EV.c"

XS_EUPXS(XS_Net__WebSocket__EV__wslay_event_context_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV__wslay_event_context_init)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "object, sock, is_server");
    {
	HV*	object;
	int	sock = (int)SvIV(ST(1))
;
	int	is_server = (int)SvIV(ST(2))
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::_wslay_event_context_init",
				"object");
		}
	} STMT_END
;
#line 424 "EV.xs"
		websocket_object* websock_object = malloc(sizeof(websocket_object));

		ev_io_init (&(websock_object->io), wslay_io_event , sock, EV_READ );

		websock_object->io.data = websock_object;

		websock_object->queue_wait_cb = NULL;
		websock_object->read_stopped = 0;
		websock_object->write_stopped = 0;

		sv_magicext (object , 0, PERL_MAGIC_ext, NULL, (const char *) websock_object , 0);
		websock_object->perl_callbacks = object;


		websock_object->callbacks.recv_callback = recv_callback;
		websock_object->callbacks.send_callback = send_callback;

		websock_object->callbacks.genmask_callback = genmask_callback;

		websock_object->callbacks.on_frame_recv_start_callback = hv_exists(object, "on_frame_recv_start", strlen("on_frame_recv_start") ) ? on_frame_recv_start_callback : NULL;

		websock_object->callbacks.on_frame_recv_chunk_callback = hv_exists(object, "on_frame_recv_chunk", strlen("on_frame_recv_chunk") ) ? on_frame_recv_chunk_callback : NULL;

		websock_object->callbacks.on_frame_recv_end_callback = hv_exists(object, "on_frame_recv_end", strlen("on_frame_recv_end") ) ? on_frame_recv_end_callback : NULL;

		websock_object->callbacks.on_msg_recv_callback = 
			hv_exists(object, "on_msg_recv", strlen("on_msg_recv") ) ? on_msg_recv_callback : NULL;

		if( 
			is_server ?
				wslay_event_context_server_init(&(websock_object->ctx), &(websock_object->callbacks), websock_object)
			:
				wslay_event_context_client_init(&(websock_object->ctx), &(websock_object->callbacks), websock_object)

		){
			croak("Can't initialize! WSLAY_ERR_NOMEM \n");
		}

		wait_io_event(websock_object);
#line 629 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV__wslay_event_config_set_no_buffering); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV__wslay_event_config_set_no_buffering)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "object, buffering");
    {
	HV*	object;
	int	buffering = (int)SvIV(ST(1))
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::_wslay_event_config_set_no_buffering",
				"object");
		}
	} STMT_END
;
#line 469 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);
		wslay_event_config_set_no_buffering(websock_object->ctx, buffering);
#line 662 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV__wslay_event_config_set_max_recv_msg_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV__wslay_event_config_set_max_recv_msg_length)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "object, len");
    {
	HV*	object;
	int	len = (int)SvIV(ST(1))
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::_wslay_event_config_set_max_recv_msg_length",
				"object");
		}
	} STMT_END
;
#line 477 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);
		wslay_event_config_set_max_recv_msg_length(websock_object->ctx, len);
#line 695 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV_shutdown_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_shutdown_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    {
	HV*	object;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::shutdown_read",
				"object");
		}
	} STMT_END
;
#line 483 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);
		wslay_event_shutdown_read(websock_object->ctx);
#line 726 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV_shutdown_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_shutdown_write)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    {
	HV*	object;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::shutdown_write",
				"object");
		}
	} STMT_END
;
#line 489 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);
		wslay_event_shutdown_write(websock_object->ctx);
#line 757 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    {
	HV*	object;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::stop",
				"object");
		}
	} STMT_END
;
#line 495 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);
		websock_object->read_stopped = 1;
		websock_object->write_stopped = 1;
		wait_io_event(websock_object);
#line 790 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV_stop_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_stop_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    {
	HV*	object;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::stop_read",
				"object");
		}
	} STMT_END
;
#line 503 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);
		websock_object->read_stopped = 1;
		wait_io_event(websock_object);		
#line 822 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV_stop_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_stop_write)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    {
	HV*	object;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::stop_write",
				"object");
		}
	} STMT_END
;
#line 510 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);
		websock_object->write_stopped = 1;
		wait_io_event(websock_object);	
#line 854 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    {
	HV*	object;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::start",
				"object");
		}
	} STMT_END
;
#line 518 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);
		websock_object->read_stopped = 0;
		websock_object->write_stopped = 0;
		wait_io_event(websock_object);		
#line 887 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV_start_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_start_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    {
	HV*	object;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::start_read",
				"object");
		}
	} STMT_END
;
#line 526 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);
		websock_object->read_stopped = 0;
		wait_io_event(websock_object);		
#line 919 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV_start_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_start_write)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    {
	HV*	object;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::start_write",
				"object");
		}
	} STMT_END
;
#line 533 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);
		websock_object->write_stopped = 0;
		wait_io_event(websock_object);	
#line 951 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV__set_waiter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV__set_waiter)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "object, waiter");
    {
	HV*	object;
	SV*	waiter = ST(1)
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::_set_waiter",
				"object");
		}
	} STMT_END
;
#line 542 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);

		if(websock_object->queue_wait_cb){
			SvREFCNT_dec(websock_object->queue_wait_cb);
		}

		websock_object->queue_wait_cb = waiter;
		SvREFCNT_inc(waiter);
#line 990 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__WebSocket__EV_queue_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_queue_msg)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "object, data, opcode=1");
    {
	HV*	object;
	SV*	data = ST(1)
;
	int	opcode;
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::queue_msg",
				"object");
		}
	} STMT_END
;

	if (items < 3)
	    opcode = 1;
	else {
	    opcode = (int)SvIV(ST(2))
;
	}
#line 556 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);

		STRLEN len;
		struct wslay_event_msg msg;

		msg.msg = SvPV(data, len);
		msg.msg_length = len;
		msg.opcode = opcode;

		int result = wslay_event_queue_msg(websock_object->ctx, &msg);

		if(result == WSLAY_ERR_INVALID_ARGUMENT){
			croak("Wslay queue_msg - WSLAY_ERR_INVALID_ARGUMENT");
		}
		if(result == WSLAY_ERR_NOMEM){
			croak("Wslay queue_msg - WSLAY_ERR_NOMEM");
		}

		wait_io_event(websock_object);

		RETVAL = result;
#line 1052 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__WebSocket__EV_queue_fragmented); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_queue_fragmented)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "object, cb, opcode=2");
    {
	HV*	object;
	SV*	cb = ST(1)
;
	int	opcode;
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::queue_fragmented",
				"object");
		}
	} STMT_END
;

	if (items < 3)
	    opcode = 2;
	else {
	    opcode = (int)SvIV(ST(2))
;
	}
#line 585 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);

		struct wslay_event_fragmented_msg msg;
		msg.opcode = opcode;
		msg.source.data = SvREFCNT_inc(cb);
		msg.read_callback = fragmented_msg_callback;

		int result = wslay_event_queue_fragmented_msg(websock_object->ctx, &msg);

		if(result == WSLAY_ERR_INVALID_ARGUMENT){
			croak("Wslay queue_fragmented - WSLAY_ERR_INVALID_ARGUMENT");
		}
		if(result == WSLAY_ERR_NOMEM){
			croak("Wslay queue_fragmented - WSLAY_ERR_NOMEM");
		}

		wait_io_event(websock_object);

		RETVAL = result;
#line 1113 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__WebSocket__EV_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_close)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "object, status_code = 0, data = NULL");
    {
	HV*	object;
	int	status_code;
	SV*	data;
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::close",
				"object");
		}
	} STMT_END
;

	if (items < 2)
	    status_code = 0;
	else {
	    status_code = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    data = NULL;
	else {
	    data = ST(2)
;
	}
#line 612 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);

		STRLEN reason_length = 0;
		char *reason; 
		if(data){
			reason = SvPV(data, reason_length);
		}

		int result = wslay_event_queue_close(websock_object->ctx, status_code, reason, reason_length);

		if(result == WSLAY_ERR_INVALID_ARGUMENT){
			croak("Wslay send - WSLAY_ERR_INVALID_ARGUMENT");
		}
		if(result == WSLAY_ERR_NOMEM){
			croak("Wslay send - WSLAY_ERR_NOMEM");
		}

		wslay_event_shutdown_read(websock_object->ctx); 
		wait_io_event(websock_object);

		RETVAL = result;
#line 1182 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__WebSocket__EV_queued_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_queued_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    {
	HV*	object;
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::queued_count",
				"object");
		}
	} STMT_END
;
#line 639 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);
		RETVAL = wslay_event_get_queued_msg_count(websock_object->ctx);
#line 1216 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__WebSocket__EV_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__WebSocket__EV_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "object");
    {
	HV*	object;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    object = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::WebSocket::EV::DESTROY",
				"object");
		}
	} STMT_END
;
#line 647 "EV.xs"
		websocket_object* websock_object  = get_wslay_context(object);

		if(websock_object->queue_wait_cb){
			SvREFCNT_dec(websock_object->queue_wait_cb);
		}

		if(websock_object->ctx){
			close_connection(websock_object);
		}
		free(websock_object);
#line 1256 "EV.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Net__WebSocket__EV); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__WebSocket__EV)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Net::WebSocket::EV::_wslay_event_context_init", XS_Net__WebSocket__EV__wslay_event_context_init);
        newXS_deffile("Net::WebSocket::EV::_wslay_event_config_set_no_buffering", XS_Net__WebSocket__EV__wslay_event_config_set_no_buffering);
        newXS_deffile("Net::WebSocket::EV::_wslay_event_config_set_max_recv_msg_length", XS_Net__WebSocket__EV__wslay_event_config_set_max_recv_msg_length);
        newXS_deffile("Net::WebSocket::EV::shutdown_read", XS_Net__WebSocket__EV_shutdown_read);
        newXS_deffile("Net::WebSocket::EV::shutdown_write", XS_Net__WebSocket__EV_shutdown_write);
        newXS_deffile("Net::WebSocket::EV::stop", XS_Net__WebSocket__EV_stop);
        newXS_deffile("Net::WebSocket::EV::stop_read", XS_Net__WebSocket__EV_stop_read);
        newXS_deffile("Net::WebSocket::EV::stop_write", XS_Net__WebSocket__EV_stop_write);
        newXS_deffile("Net::WebSocket::EV::start", XS_Net__WebSocket__EV_start);
        newXS_deffile("Net::WebSocket::EV::start_read", XS_Net__WebSocket__EV_start_read);
        newXS_deffile("Net::WebSocket::EV::start_write", XS_Net__WebSocket__EV_start_write);
        newXS_deffile("Net::WebSocket::EV::_set_waiter", XS_Net__WebSocket__EV__set_waiter);
        newXS_deffile("Net::WebSocket::EV::queue_msg", XS_Net__WebSocket__EV_queue_msg);
        newXS_deffile("Net::WebSocket::EV::queue_fragmented", XS_Net__WebSocket__EV_queue_fragmented);
        newXS_deffile("Net::WebSocket::EV::close", XS_Net__WebSocket__EV_close);
        newXS_deffile("Net::WebSocket::EV::queued_count", XS_Net__WebSocket__EV_queued_count);
        newXS_deffile("Net::WebSocket::EV::DESTROY", XS_Net__WebSocket__EV_DESTROY);

    /* Initialisation Section */

#line 411 "EV.xs"
{
	I_EV_API ("Net::WebSocket::EV");
#ifdef WIN32
	_setmaxstdio(2048); 
#endif
}

#line 1317 "EV.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

